# .../host_common/include/ #

This directory holds across-all-repos common include files.

All header files in this directory are intended to be OS-agnostic. If an OS-specific construct is used, it MUST be suitably protected within conditional-compilation guards.

All header files in this directory are intended to be released to our customers if/as any of our Sample code includes these header files. As such, these header files MUST be "best in class" -- whatever that means (Warning free; clearly written, not "clever" in ways that make them unreadable; etc.)

# silabs_version.h #

silabs_version.h contains information useful in defining the version of the product being built. Useful items are Copyright, Company name, etc. to provide a common "look and appearance" of these in all of our software across all of our products/modules.

One construct is the version number. The version number is defined as a four-field dotted decimal format of major.minor.release.build. The build field is typically filled in automajically by the (Jenkins or similar) automated build environment. The other three fields typically increment somewhat subjectively based on whether recent changes constitute a "major change" or a "minor change" or a "re-spin release change".

In addition to the "somewhat subjective" bumps of the major.minor.release fields, one convention to uphold is that when a driver package is successfully submitted to the Microsoft WHQL Dashboard submission process, and the resulting signed driver package is downloaded from that WHQL Dashboard and archived to the DriverPackage repo, that the "release" field in this file be bumped (so that ongoing builds are of the next version number, not the already signed, version number).

# silabs_sdkddkversion.h #

silabs_sdkddkversion.h is a Windows-specific header file defining various constructs to standardize our building of our software products in the Microsoft build environment, and the SDK and DDK therein specifically. In summary, this header file ensures/enforces/enables our building of our software for a minimum targeted OS of Windows 7 on x86 and x64 and a minimum targeted OS of Windows 10 on ARM.

# silabs_defs.h #

silabs_defs.h contains common defines/enums aimed at reducing duplicated defines throughout our repos.

# silabs_utils.h #

silabs_utils.h contains "utility" constructs aimed at reducing code-reuse-via-cut-n-paste.


## Conventions ##

* Style for source code, file naming, etc will be per the Silicon Labs
  MCU style guide:
  https://stash.silabs.com/projects/MCU8_FW/repos/ff_process/browse/process-documents/coding-standard.md
* All attempts should be made to avoid copy-pasting chunks of code between
  projects.  Instead figure out what is being shared and make a shared
  library/driver.
* The code in this repository is not intended to be made public.  However it
  should be coded in a style and quality as if it were to be public-facing.
* Large binary document files (word, excel, PDFs, images) should generally
  not be placed in this repository.

**NOTE**
This is a note.
